class Pngquant < Formula
  desc "PNG image optimizing utility"
  homepage "https://pngquant.org/"
  url "https://static.crates.io/crates/pngquant/pngquant-3.0.3.crate"
  sha256 "68a12bdd8825f9989f4ee9a6ab0b42727dae57728b939ef63453366697a07232"
  license :cannot_represent
  head "https://github.com/kornelski/pngquant.git", branch: "main"

  livecheck do
    url "https://crates.io/api/v1/crates/pngquant/versions"
    regex(/^v?(\d+(?:\.\d+)+)$/i)
    strategy :json do |json|
      json["versions"]&.map do |version|
        next if version["yanked"] == true
        next if (match = version["num"]&.match(regex)).blank?

        match[1]
      end
    end
  end

  depends_on "pkg-config" => :build
  depends_on "rust" => :build
  depends_on "libpng"
  depends_on "little-cms2"

  def install
    system "tar", "--strip-components", "1", "-xzvf", "pngquant-#{version}.crate"
    system "cargo", "install", *std_cargo_args
  end

  test do
    system "#{bin}/pngquant", test_fixtures("test.png"), "-o", "out.png"
    assert_predicate testpath/"out.png", :exist?
  end
end
